#include <iostream>
using namespace std;

#include "Player.h"
#include "Lobby.h"
#include <fstream>
#include <sstream>

int main()
{
  //Create lobbies and add to array
  const unsigned maxLobbies = 4;
  const unsigned maxPlayers = 6;
  Lobby lobbies[maxLobbies];

  Lobby l1(maxPlayers);
  Lobby l2(maxPlayers);
  Lobby l3(maxPlayers);
  Lobby l4(maxPlayers);

  lobbies[0] = l1;
  lobbies[1] = l2;
  lobbies[2] = l3;
  lobbies[3] = l4;

  //open file and read lines
  ifstream myfile("PlayersList.txt");
  if(myfile.is_open())
  {
    while(!myfile.eof()) //while not at end of file
    {
      string username;
      string rankStr;
      int rank;
      //store player data into strings
      getline(myfile, username, '-');
      getline(myfile, rankStr, '\n');
      //convert rank string to int
      stringstream conversion(rankStr);
      conversion >> rank;
      //create player object
      Player p(username, rank);
      cout<<"Displaying current player"<<endl;
      p.displayName();
      cout<<p.getRank()<<endl;
      //enqueue and repeat with next player
      bool sorted = false;
      for (unsigned i = 0; i < maxLobbies && sorted == false; i++) {
        if (lobbies[i].getAverage() == 0) {
          lobbies[i].addPlayer(p);
          sorted = true;
        }
        else if (p.getRank() <= lobbies[i].getAverage() +5 &&
                 p.getRank() >= lobbies[i].getAverage() -5 &&
                 lobbies[i].getSize() < maxPlayers ) {
          lobbies[i].addPlayer(p);
          sorted = true;
        }
      }
      if (sorted == false) {
        //Place player in waiting queue
        cout<<"Player placed in wait queue"<<endl;
      }
      //Display lobbies
      for (unsigned i = 0; i > maxLobbies && sorted == false; i++) {
        cout<<"Displaying Lobby "<<i+1<<":"<<endl;
        lobbies[i].display();
      }
    }
  }
  else cout<<"file cannot open";

  return 0;
}
